<script setup lang="ts">
import { onMounted, reactive } from "vue";
import { WorkflowVersionStatus } from "@/client/types.gen";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { determineGitIcon } from "@/utils/GitRepository";
import { sortedVersions } from "@/utils/Workflow";
import { useWorkflowStore } from "@/stores/workflows";
import { useUserStore } from "@/stores/users";
import { useNameStore } from "@/stores/names";
import dayjs from "dayjs";
import { Tooltip } from "bootstrap";

const workflowRepository = useWorkflowStore();
const nameRepository = useNameStore();
const userRepository = useUserStore();

const workflowsState = reactive<{
  loading: boolean;
  versionUpdateLoading: string;
}>({
  loading: true,
  versionUpdateLoading: "",
});

function updateWorkflowVersionStatus(
  workflow_id: string,
  git_commit_hash: string,
  new_status: WorkflowVersionStatus,
) {
  workflowsState.versionUpdateLoading = git_commit_hash;
  workflowRepository
    .updateVersionStatus(workflow_id, git_commit_hash, new_status)
    .finally(() => {
      workflowsState.versionUpdateLoading = "";
    });
}

onMounted(() => {
  workflowRepository
    .fetchReviewableWorkflows(() => {
      workflowsState.loading = false;
    })
    .then((workflows) => {
      setTimeout(() => {
        document
          .querySelector("#reviewTable")
          ?.querySelectorAll('[data-bs-toggle="tooltip"]')
          ?.forEach((tooltipTriggerEl) =>
            Tooltip.getOrCreateInstance(tooltipTriggerEl),
          );
      }, 1000);
      return workflows;
    })
    .then((workflows) => workflows.map((workflow) => workflow.developer_id))
    .then(userRepository.fetchUsernames);
});
</script>

<template>
  <div class="row border-bottom mb-4">
    <h2 class="mb-2">Workflow Reviews</h2>
  </div>
  <div v-if="workflowsState.loading" class="text-center mt-5">
    <div class="spinner-border" style="width: 3rem; height: 3rem" role="status">
      <span class="visually-hidden">Loading...</span>
    </div>
  </div>
  <table
    v-else-if="workflowRepository.reviewableWorkflows.length > 0"
    id="reviewTable"
    class="table table-striped mx-auto"
  >
    <thead class="fs-5">
      <tr>
        <th scope="col">Workflow Name</th>
        <th scope="col" class="w-50">Description</th>
        <th scope="col">Repository</th>
        <th scope="col">Developer</th>
      </tr>
    </thead>
    <tbody v-if="!workflowsState.loading">
      <template
        v-for="workflow in workflowRepository.reviewableWorkflows"
        :key="workflow.workflow_id"
      >
        <tr>
          <td class="text-center">{{ workflow.name }}</td>
          <td>{{ workflow.short_description }}</td>
          <td>
            <a :href="workflow.repository_url" target="_blank">
              <font-awesome-icon
                :icon="determineGitIcon(workflow.repository_url)"
              />
              {{ workflow.repository_url }}
            </a>
          </td>
          <td v-if="nameRepository.getName(workflow.developer_id)">
            {{ nameRepository.getName(workflow.developer_id) }}
          </td>
          <td v-else class="placeholder-glow">
            <div class="placeholder w-75"></div>
          </td>
        </tr>
        <tr>
          <td colspan="4" class="px-5">
            <table class="table mb-0">
              <tbody class="text-center">
                <tr
                  v-for="version in sortedVersions(workflow.versions)"
                  :key="version.workflow_version_id"
                >
                  <td class="text-end">
                    <img
                      v-if="version.icon_url"
                      :src="version.icon_url"
                      class="img-fluid"
                      alt="Workflow Icon"
                    />
                  </td>
                  <td class="text-start">{{ version.version }}</td>
                  <td>
                    <span
                      data-bs-toggle="tooltip"
                      :data-bs-title="
                        dayjs
                          .unix(version?.created_at)
                          .format('MMM DD, YYYY HH:mm:ss')
                      "
                      >{{ dayjs.unix(version.created_at).fromNow() }}</span
                    >
                  </td>
                  <td>{{ version.status }}</td>
                  <td>
                    <a
                      :href="
                        workflow.repository_url +
                        '/tree/' +
                        version.workflow_version_id
                      "
                      target="_blank"
                    >
                      <font-awesome-icon
                        :icon="determineGitIcon(workflow.repository_url)"
                      />
                      {{ version.workflow_version_id }}
                    </a>
                  </td>
                  <td>#Modes: {{ version.modes?.length ?? 0 }}</td>
                  <td>
                    <router-link
                      :to="{
                        name: 'workflow-version',
                        params: {
                          workflowId: workflow.workflow_id,
                          versionId: version.workflow_version_id,
                        },
                        query: {
                          developerView: 'true',
                          workflowModeId: (version.modes ?? [])[0],
                        },
                      }"
                    >
                      View
                    </router-link>
                  </td>
                  <td class="text-end">
                    <div
                      v-if="
                        workflowsState.versionUpdateLoading ===
                        version.workflow_version_id
                      "
                      class="spinner-border text-light spinner-border-sm"
                      role="status"
                    >
                      <span class="visually-hidden">Loading...</span>
                    </div>
                    <div
                      v-else-if="
                        version.status === WorkflowVersionStatus.PUBLISHED
                      "
                    >
                      <font-awesome-icon
                        icon="fa-solid fa-circle-check"
                        class="text-success"
                      />
                    </div>
                    <div
                      v-else-if="
                        version.status === WorkflowVersionStatus.DENIED
                      "
                    >
                      <font-awesome-icon
                        icon="fa-solid fa-x"
                        class="text-danger"
                      />
                    </div>
                    <div
                      v-else-if="
                        version.status === WorkflowVersionStatus.DEPRECATED
                      "
                    >
                      <font-awesome-icon
                        icon="fa-solid fa-archive"
                        class="text-warning"
                      />
                    </div>
                    <div v-else class="btn-group">
                      <button
                        type="button"
                        class="btn btn-success btn-sm"
                        @click="
                          updateWorkflowVersionStatus(
                            workflow.workflow_id,
                            version.workflow_version_id,
                            WorkflowVersionStatus.PUBLISHED,
                          )
                        "
                      >
                        Publish
                      </button>
                      <button
                        type="button"
                        class="btn btn-danger btn-sm"
                        @click="
                          updateWorkflowVersionStatus(
                            workflow.workflow_id,
                            version.workflow_version_id,
                            WorkflowVersionStatus.DENIED,
                          )
                        "
                      >
                        Deny
                      </button>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </td>
        </tr>
      </template>
    </tbody>
  </table>
  <div v-else class="text-center mt-5 fs-4">
    There are currently no workflows to review
  </div>
</template>

<style scoped>
img {
  padding: 0 !important;
  max-width: 1.2em;
  max-height: 1.2em;
}
</style>
